/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#include "ch32v20x.h"
#include "ch32v20x_exti.h"
#include <rtthread.h>
#include <rthw.h>
#include "drivers/pin.h"

/* Global typedef */

/* Global define */

/* LED0 is driven by the pin driver interface of rt  */
#define LED0_PIN  11   //PA1

/* Global Variable */


void EXTIx_INT_INIT(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure={0};
  EXTI_InitTypeDef  EXTI_InitStructure={0};
  NVIC_InitTypeDef  NVIC_InitStructure={0};

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOA,ENABLE); //ʹܸùʱӺGPIOAʱ

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3;       //GPIO
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;              //GPIOģʽ
  GPIO_Init(GPIOA, &GPIO_InitStructure);                     //ʼGPIOA

   /* GPIOA ----> EXTI_Line0 */
  GPIO_EXTILineConfig(GPIO_PortSourceGPIOA,GPIO_PinSource2); //ָж/¼ߵԴʵ趨ⲿжüĴAFIO_EXTICRxֵ˴ΪPA0
  GPIO_EXTILineConfig(GPIO_PortSourceGPIOA,GPIO_PinSource3);
  EXTI_InitStructure.EXTI_Line=EXTI_Line2|EXTI_Line3;        //EXTIж/¼ѡ񣬴˴ѡEXTI_Line0
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;        //EXTIģʽѡ񣬴˴ѡΪжģʽ
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;    //EXTIش¼˴ѡΪ½ش
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;                  //ʹEXTI
  EXTI_Init(&EXTI_InitStructure);

  EXTI_ClearITPendingBit(EXTI_Line2);
  EXTI_ClearITPendingBit(EXTI_Line3);

  NVIC_InitStructure.NVIC_IRQChannel = EXTI2_IRQn;           //ʹEXTI0жͨ
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼΪ0
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;         //ȼΪ1
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);                            //жȼʼ

  NVIC_InitStructure.NVIC_IRQChannel = EXTI3_IRQn;           //ʹEXTI0жͨ
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;  //ռȼΪ1
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;         //ȼΪ1
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);
}



/* main is just one of the threads, in addition to tshell,idle
 *    main is just an LED blinking, the main thread is registered in rtthread_startup,
 *    tshell uses the serial port to receive interrupts, and the interrupt stack and thread stack are
 *    used separately.Note that when entering an interrupt, the 16caller register needs to be pushed 
 *    into the thread stack
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    SystemCoreClockUpdate();
    rt_kprintf("\r\n MCU: CH32V20x\r\n");
	rt_kprintf(" SysClk: %dHz\r\n",SystemCoreClock);
    rt_kprintf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
    rt_kprintf(" www.wch.cn\r\n");

	EXTIx_INT_INIT();

	while(1)
	{

	}
}


/* Test using the driver interface to operate the I/O port  */
int led(void)
{
    rt_uint8_t count;

    rt_pin_mode(LED0_PIN, PIN_MODE_OUTPUT);
    printf("led_SP:%08x\r\n",__get_SP());
    for(count = 0 ; count < 10 ;count++)
    {
        rt_pin_write(LED0_PIN, PIN_LOW);
        rt_kprintf("led on, count : %d\r\n", count);
        rt_thread_mdelay(500);

        rt_pin_write(LED0_PIN, PIN_HIGH);
        rt_kprintf("led off\r\n");
        rt_thread_mdelay(500);
    }
    return 0;
}
MSH_CMD_EXPORT(led,  led sample by using I/O drivers);



